Index: pjproject/trunk/pjmedia/src/pjmedia/transport_udp.c
===================================================================
--- pjproject/trunk/pjmedia/src/pjmedia/transport_udp.c	(revision 1265)
+++ pjproject/trunk/pjmedia/src/pjmedia/transport_udp.c	(revision 1266)
@@ -235,5 +235,5 @@
 	return PJ_ENOMEM;
 
-    tp = pj_pool_zalloc(pool, sizeof(struct transport_udp));
+    tp = PJ_POOL_ZALLOC_T(pool, struct transport_udp);
     tp->pool = pool;
     tp->options = options;
@@ -379,5 +379,5 @@
     PJ_UNUSED_ARG(op_key);
 
-    udp = pj_ioqueue_get_user_data(key);
+    udp = (struct transport_udp*) pj_ioqueue_get_user_data(key);
 
     do {
@@ -480,5 +480,5 @@
     PJ_UNUSED_ARG(op_key);
 
-    udp = pj_ioqueue_get_user_data(key);
+    udp = (struct transport_udp*) pj_ioqueue_get_user_data(key);
 
     do {
@@ -568,5 +568,5 @@
 
     /* Copy remote RTP address, if one is specified. */
-    rtcp_addr = rem_rtcp;
+    rtcp_addr = (const pj_sockaddr_in*) rem_rtcp;
     if (rtcp_addr && rtcp_addr->sin_addr.s_addr != 0) {
 	pj_memcpy(&udp->rem_rtcp_addr, rem_rtcp, sizeof(pj_sockaddr_in));
Index: pjproject/trunk/pjmedia/src/pjmedia/wav_player.c
===================================================================
--- pjproject/trunk/pjmedia/src/pjmedia/wav_player.c	(revision 1265)
+++ pjproject/trunk/pjmedia/src/pjmedia/wav_player.c	(revision 1266)
@@ -80,5 +80,5 @@
     struct file_port *port;
 
-    port = pj_pool_zalloc(pool, sizeof(struct file_port));
+    port = PJ_POOL_ZALLOC_T(pool, struct file_port);
     if (!port)
 	return NULL;
@@ -350,5 +350,5 @@
 
     /* Create buffer. */
-    fport->buf = pj_pool_alloc(pool, fport->bufsize);
+    fport->buf = (char*) pj_pool_alloc(pool, fport->bufsize);
     if (!fport->buf) {
 	pj_file_close(fport->fd);
Index: pjproject/trunk/pjmedia/src/pjmedia/wav_playlist.c
===================================================================
--- pjproject/trunk/pjmedia/src/pjmedia/wav_playlist.c	(revision 1265)
+++ pjproject/trunk/pjmedia/src/pjmedia/wav_playlist.c	(revision 1266)
@@ -85,5 +85,5 @@
     struct playlist_port *port;
 
-    port = pj_pool_zalloc(pool, sizeof(struct playlist_port));
+    port = PJ_POOL_ZALLOC_T(pool, struct playlist_port);
     if (!port)
 	return NULL;
@@ -276,5 +276,6 @@
 
     /* Create file descriptor list */
-    fport->fd_list = pj_pool_zalloc(pool, sizeof(pj_oshandle_t)*file_count);
+    fport->fd_list = (pj_oshandle_t*)
+		     pj_pool_zalloc(pool, sizeof(pj_oshandle_t)*file_count);
     if (!fport->fd_list) {
 	return PJ_ENOMEM;
@@ -282,5 +283,6 @@
 
     /* Create file size list */
-    fport->fsize_list = pj_pool_alloc(pool, sizeof(pj_off_t)*file_count);
+    fport->fsize_list = (pj_off_t*)
+			pj_pool_alloc(pool, sizeof(pj_off_t)*file_count);
     if (!fport->fsize_list) {
 	return PJ_ENOMEM;
@@ -288,5 +290,6 @@
 
     /* Create start of WAVE data list */
-    fport->start_data_list = pj_pool_alloc(pool, sizeof(unsigned)*file_count);
+    fport->start_data_list = (unsigned*)
+			     pj_pool_alloc(pool, sizeof(unsigned)*file_count);
     if (!fport->start_data_list) {
 	return PJ_ENOMEM;
@@ -294,5 +297,6 @@
 
     /* Create file position list */
-    fport->fpos_list = pj_pool_alloc(pool, sizeof(pj_off_t)*file_count);
+    fport->fpos_list = (pj_off_t*)
+		       pj_pool_alloc(pool, sizeof(pj_off_t)*file_count);
     if (!fport->fpos_list) {
 	return PJ_ENOMEM;
@@ -306,5 +310,5 @@
 
     /* Create buffer. */
-    fport->buf = pj_pool_alloc(pool, fport->bufsize);
+    fport->buf = (char*) pj_pool_alloc(pool, fport->bufsize);
     if (!fport->buf) {
 	return PJ_ENOMEM;
Index: pjproject/trunk/pjmedia/src/pjmedia/wav_writer.c
===================================================================
--- pjproject/trunk/pjmedia/src/pjmedia/wav_writer.c	(revision 1265)
+++ pjproject/trunk/pjmedia/src/pjmedia/wav_writer.c	(revision 1266)
@@ -84,5 +84,5 @@
 
     /* Create file port instance. */
-    fport = pj_pool_zalloc(pool, sizeof(struct file_port));
+    fport = PJ_POOL_ZALLOC_T(pool, struct file_port);
     PJ_ASSERT_RETURN(fport != NULL, PJ_ENOMEM);
 
@@ -150,5 +150,5 @@
 
     /* Allocate buffer and set initial write position */
-    fport->buf = pj_pool_alloc(pool, fport->bufsize);
+    fport->buf = (char*) pj_pool_alloc(pool, fport->bufsize);
     if (fport->buf == NULL) {
 	pj_file_close(fport->fd);
Index: pjproject/trunk/pjnath/src/pjnath/stun_msg.c
===================================================================
--- pjproject/trunk/pjnath/src/pjnath/stun_msg.c	(revision 1265)
+++ pjproject/trunk/pjnath/src/pjnath/stun_msg.c	(revision 1266)
@@ -18,4 +18,5 @@
  */
 #include <pjnath/stun_msg.h>
+#include <pjnath/stun_auth.h>
 #include <pjnath/errno.h>
 #include <pjlib-util/crc32.h>
Index: pjproject/trunk/pjnath/src/pjstun-client/client_main.c
===================================================================
--- pjproject/trunk/pjnath/src/pjstun-client/client_main.c	(revision 1265)
+++ pjproject/trunk/pjnath/src/pjstun-client/client_main.c	(revision 1266)
@@ -28,5 +28,5 @@
 #define REQ_TRANSPORT	-1		    /* 0: udp, 1: tcp, -1: disable */
 #define REQ_PORT_PROPS	-1		    /* -1 to disable */
-#define REQ_IP		NULL		    /* IP address string */
+#define REQ_IP		0		    /* IP address string */
 
 //#define OPTIONS		PJ_STUN_NO_AUTHENTICATE
@@ -355,5 +355,5 @@
 	}
 
-	if (REQ_IP != NULL) {
+	if (REQ_IP) {
 	    pj_sockaddr_in addr;
 	    pj_str_t tmp;
Index: pjproject/trunk/pjnath/src/pjstun-srv-test/server.c
===================================================================
--- pjproject/trunk/pjnath/src/pjstun-srv-test/server.c	(revision 1265)
+++ pjproject/trunk/pjnath/src/pjstun-srv-test/server.c	(revision 1266)
@@ -88,5 +88,6 @@
 
     srv->si.thread_cnt = thread_cnt;
-    srv->threads = pj_pool_calloc(pool, thread_cnt, sizeof(pj_thread_t*));
+    srv->threads = (pj_thread_t**)
+		   pj_pool_calloc(pool, thread_cnt, sizeof(pj_thread_t*));
     for (i=0; i<thread_cnt; ++i) {
 	status = pj_thread_create(pool, "worker%p", &worker_thread,
Index: pjproject/trunk/pjnath/src/pjstun-srv-test/turn_usage.c
===================================================================
--- pjproject/trunk/pjnath/src/pjstun-srv-test/turn_usage.c	(revision 1265)
+++ pjproject/trunk/pjnath/src/pjstun-srv-test/turn_usage.c	(revision 1266)
@@ -286,5 +286,5 @@
 
     if (client) {
-	status = pj_stun_msg_check(pkt, pkt_size, flags);
+	status = pj_stun_msg_check((const pj_uint8_t*)pkt, pkt_size, flags);
 
 	if (status == PJ_SUCCESS) {
@@ -1355,5 +1355,5 @@
     PJ_UNUSED_ARG(op_key);
 
-    client = pj_ioqueue_get_user_data(key);
+    client = (struct turn_client*) pj_ioqueue_get_user_data(key);
     
     /* Lock client */
Index: pjproject/trunk/pjnath/src/pjstun-srv-test/usage.c
===================================================================
--- pjproject/trunk/pjnath/src/pjstun-srv-test/usage.c	(revision 1265)
+++ pjproject/trunk/pjnath/src/pjstun-srv-test/usage.c	(revision 1266)
@@ -100,6 +100,6 @@
 
     usage->worker_cnt = si->thread_cnt;
-    usage->worker = pj_pool_calloc(pool, si->thread_cnt, 
-				   sizeof(struct worker));
+    usage->worker = (struct worker*) pj_pool_calloc(pool, si->thread_cnt, 
+				   		    sizeof(struct worker));
     for (i=0; i<si->thread_cnt; ++i) {
 	pj_ioqueue_op_key_init(&usage->worker[i].read_key, 
@@ -109,5 +109,6 @@
 
     usage->send_count = usage->worker_cnt * 2;
-    usage->send_key = pj_pool_calloc(pool, usage->send_count, 
+    usage->send_key = (pj_ioqueue_op_key_t*)
+		      pj_pool_calloc(pool, usage->send_count, 
 				     sizeof(pj_ioqueue_op_key_t));
     for (i=0; i<usage->send_count; ++i) {
@@ -241,5 +242,5 @@
 {
     enum { MAX_LOOP = 10 };
-    pj_stun_usage *usage = pj_ioqueue_get_user_data(key);
+    pj_stun_usage *usage = (pj_stun_usage*) pj_ioqueue_get_user_data(key);
     struct worker *worker = (struct worker*) op_key;
     unsigned count;
Index: pjproject/trunk/pjsip/build/Makefile
===================================================================
--- pjproject/trunk/pjsip/build/Makefile	(revision 1265)
+++ pjproject/trunk/pjsip/build/Makefile	(revision 1266)
@@ -90,5 +90,5 @@
 		    tsx_uas_test.o txdata_test.o uri_test.o
 export TEST_CFLAGS += $(_CFLAGS)
-export TEST_LDFLAGS += $(PJ_LDFLAGS) $(PJ_LDLIBS)
+export TEST_LDFLAGS += $(PJ_LDFLAGS) $(PJ_LDLIBS) $(LDFLAGS)
 export TEST_EXE := ../bin/pjsip-test-$(TARGET_NAME)$(HOST_EXE)
 
Index: pjproject/trunk/pjsip/src/pjsip-simple/presence.c
===================================================================
--- pjproject/trunk/pjsip/src/pjsip-simple/presence.c	(revision 1265)
+++ pjproject/trunk/pjsip/src/pjsip-simple/presence.c	(revision 1266)
@@ -58,10 +58,10 @@
  * Presence message body type.
  */
-typedef enum content_type
+typedef enum content_type_e
 {
     CONTENT_TYPE_NONE,
     CONTENT_TYPE_PIDF,
     CONTENT_TYPE_XPIDF,
-} content_type;
+} content_type_e;
 
 /*
@@ -72,5 +72,5 @@
     pjsip_evsub		*sub;		/**< Event subscribtion record.	    */
     pjsip_dialog	*dlg;		/**< The dialog.		    */
-    content_type	 content_type;	/**< Content-Type.		    */
+    content_type_e	 content_type;	/**< Content-Type.		    */
     pjsip_pres_status	 status;	/**< Presence status.		    */
     pjsip_pres_status	 tmp_status;	/**< Temp, before NOTIFY is answred.*/
@@ -227,5 +227,5 @@
     pjsip_expires_hdr *expires_hdr;
     unsigned expires;
-    content_type content_type = CONTENT_TYPE_NONE;
+    content_type_e content_type = CONTENT_TYPE_NONE;
     pjsip_evsub *sub;
     pjsip_pres *pres;
Index: pjproject/trunk/pjsip/src/pjsip-ua/sip_inv.c
===================================================================
--- pjproject/trunk/pjsip/src/pjsip-ua/sip_inv.c	(revision 1265)
+++ pjproject/trunk/pjsip/src/pjsip-ua/sip_inv.c	(revision 1266)
@@ -230,5 +230,5 @@
 	return PJ_FALSE;
 
-    inv = dlg->mod_data[mod_inv.mod.id];
+    inv = (pjsip_inv_session*) dlg->mod_data[mod_inv.mod.id];
 
     /* Report to dialog that we handle INVITE, CANCEL, BYE, ACK. 
@@ -412,5 +412,5 @@
 PJ_DEF(pjsip_inv_session*) pjsip_dlg_get_inv_session(pjsip_dialog *dlg)
 {
-    return dlg->mod_data[mod_inv.mod.id];
+    return (pjsip_inv_session*) dlg->mod_data[mod_inv.mod.id];
 }
 
@@ -453,5 +453,5 @@
 
     /* Create the session */
-    inv = pj_pool_zalloc(dlg->pool, sizeof(pjsip_inv_session));
+    inv = PJ_POOL_ZALLOC_T(dlg->pool, pjsip_inv_session);
     pj_assert(inv != NULL);
 
@@ -578,6 +578,6 @@
 
 	/* Parse and validate SDP */
-	status = pjmedia_sdp_parse(rdata->tp_info.pool, body->data, body->len,
-				   &sdp);
+	status = pjmedia_sdp_parse(rdata->tp_info.pool, 
+				   (char*)body->data, body->len, &sdp);
 	if (status == PJ_SUCCESS)
 	    status = pjmedia_sdp_validate(sdp);
@@ -651,5 +651,5 @@
      * implicitly by sending this INVITE.
      */
-    allow = pjsip_msg_find_hdr(msg, PJSIP_H_ALLOW, NULL);
+    allow = (pjsip_allow_hdr*) pjsip_msg_find_hdr(msg, PJSIP_H_ALLOW, NULL);
     if (allow) {
 	unsigned i;
@@ -669,5 +669,6 @@
 
     /* Check Supported header */
-    sup_hdr = pjsip_msg_find_hdr(msg, PJSIP_H_SUPPORTED, NULL);
+    sup_hdr = (pjsip_supported_hdr*)
+	      pjsip_msg_find_hdr(msg, PJSIP_H_SUPPORTED, NULL);
     if (sup_hdr) {
 	unsigned i;
@@ -684,5 +685,6 @@
 
     /* Check Require header */
-    req_hdr = pjsip_msg_find_hdr(msg, PJSIP_H_REQUIRE, NULL);
+    req_hdr = (pjsip_require_hdr*)
+	      pjsip_msg_find_hdr(msg, PJSIP_H_REQUIRE, NULL);
     if (req_hdr) {
 	unsigned i;
@@ -743,5 +745,6 @@
 		pj_assert(h);
 		if (h) {
-		    sup_hdr = pjsip_hdr_clone(rdata->tp_info.pool, h);
+		    sup_hdr = (pjsip_supported_hdr*)
+			      pjsip_hdr_clone(rdata->tp_info.pool, h);
 		    pj_list_push_back(&res_hdr_list, sup_hdr);
 		}
@@ -783,5 +786,6 @@
 	    pj_assert(h);
 	    if (h) {
-		sup_hdr = pjsip_hdr_clone(rdata->tp_info.pool, h);
+		sup_hdr = (pjsip_supported_hdr*)
+			  pjsip_hdr_clone(rdata->tp_info.pool, h);
 		pj_list_push_back(&res_hdr_list, sup_hdr);
 	    }
@@ -815,5 +819,5 @@
 	    pjsip_hdr *cloned;
 
-	    cloned = pjsip_hdr_clone(tdata->pool, h);
+	    cloned = (pjsip_hdr*) pjsip_hdr_clone(tdata->pool, h);
 	    PJ_ASSERT_RETURN(cloned, PJ_ENOMEM);
 
@@ -875,5 +879,5 @@
 
     /* Create the session */
-    inv = pj_pool_zalloc(dlg->pool, sizeof(pjsip_inv_session));
+    inv = PJ_POOL_ZALLOC_T(dlg->pool, pjsip_inv_session);
     pj_assert(inv != NULL);
 
@@ -894,5 +898,5 @@
 
 	/* Parse and validate SDP */
-	status = pjmedia_sdp_parse(inv->pool, body->data, body->len,
+	status = pjmedia_sdp_parse(inv->pool, (char*)body->data, body->len,
 				   &rem_sdp);
 	if (status == PJ_SUCCESS)
@@ -936,6 +940,5 @@
 
     /* Attach our data to the transaction. */
-    tsx_inv_data = pj_pool_zalloc(inv->invite_tsx->pool, 
-				  sizeof(struct tsx_inv_data));
+    tsx_inv_data = PJ_POOL_ZALLOC_T(inv->invite_tsx->pool, struct tsx_inv_data);
     tsx_inv_data->inv = inv;
     inv->invite_tsx->mod_data[mod_inv.mod.id] = tsx_inv_data;
@@ -998,10 +1001,10 @@
 {
     PJ_UNUSED_ARG(len);
-    return pjmedia_sdp_session_clone(pool, data);
+    return pjmedia_sdp_session_clone(pool, (const pjmedia_sdp_session*)data);
 }
 
 static int print_sdp(pjsip_msg_body *body, char *buf, pj_size_t len)
 {
-    return pjmedia_sdp_print(body->data, buf, len);
+    return pjmedia_sdp_print((const pjmedia_sdp_session*)body->data, buf, len);
 }
 
@@ -1015,5 +1018,5 @@
     pjsip_msg_body *body;
 
-    body = pj_pool_zalloc(pool, sizeof(pjsip_msg_body));
+    body = PJ_POOL_ZALLOC_T(pool, pjsip_msg_body);
     PJ_ASSERT_RETURN(body != NULL, PJ_ENOMEM);
 
@@ -1083,5 +1086,5 @@
 
 	while (hdr != &inv->dlg->inv_hdr) {
-	    pjsip_msg_add_hdr(tdata->msg,
+	    pjsip_msg_add_hdr(tdata->msg, (pjsip_hdr*)
 			      pjsip_hdr_shallow_clone(tdata->pool, hdr));
 	    hdr = hdr->next;
@@ -1118,5 +1121,5 @@
     hdr = pjsip_endpt_get_capability(inv->dlg->endpt, PJSIP_H_ALLOW, NULL);
     if (hdr) {
-	pjsip_msg_add_hdr(tdata->msg,
+	pjsip_msg_add_hdr(tdata->msg, (pjsip_hdr*)
 			  pjsip_hdr_shallow_clone(tdata->pool, hdr));
     }
@@ -1125,5 +1128,5 @@
     hdr = pjsip_endpt_get_capability(inv->dlg->endpt, PJSIP_H_SUPPORTED, NULL);
     if (hdr) {
-	pjsip_msg_add_hdr(tdata->msg,
+	pjsip_msg_add_hdr(tdata->msg, (pjsip_hdr*)
 			  pjsip_hdr_shallow_clone(tdata->pool, hdr));
     }
@@ -1178,7 +1181,7 @@
 
     /* Get/attach invite session's transaction data */
-    tsx_inv_data = tsx->mod_data[mod_inv.mod.id];
+    tsx_inv_data = (struct tsx_inv_data*) tsx->mod_data[mod_inv.mod.id];
     if (tsx_inv_data == NULL) {
-	tsx_inv_data = pj_pool_zalloc(tsx->pool, sizeof(struct tsx_inv_data));
+	tsx_inv_data = PJ_POOL_ZALLOC_T(tsx->pool, struct tsx_inv_data);
 	tsx_inv_data->inv = inv;
 	tsx->mod_data[mod_inv.mod.id] = tsx_inv_data;
@@ -1208,5 +1211,6 @@
     /* Parse the SDP body. */
 
-    status = pjmedia_sdp_parse(rdata->tp_info.pool, msg->body->data,
+    status = pjmedia_sdp_parse(rdata->tp_info.pool, 
+			       (char*)msg->body->data,
 			       msg->body->len, &sdp);
     if (status != PJ_SUCCESS) {
@@ -1588,5 +1592,6 @@
 
 	pj_strdup_with_null(inv->dlg->pool, &tmp, new_contact);
-	contact_hdr = pjsip_parse_hdr(inv->dlg->pool, &STR_CONTACT, 
+	contact_hdr = (pjsip_contact_hdr*)
+		      pjsip_parse_hdr(inv->dlg->pool, &STR_CONTACT, 
 				      tmp.ptr, tmp.slen, NULL);
 	if (!contact_hdr) {
@@ -1685,5 +1690,5 @@
 	pjsip_dlg_inc_lock(inv->dlg);
 
-	tsx_inv_data = pj_pool_zalloc(inv->pool, sizeof(struct tsx_inv_data));
+	tsx_inv_data = PJ_POOL_ZALLOC_T(inv->pool, struct tsx_inv_data);
 	tsx_inv_data->inv = inv;
 
@@ -1701,5 +1706,5 @@
 	 * request.
 	 */
-	PJ_ASSERT_RETURN((cseq=pjsip_msg_find_hdr(tdata->msg, PJSIP_H_CSEQ, NULL))!=NULL
+	PJ_ASSERT_RETURN((cseq=(pjsip_cseq_hdr*)pjsip_msg_find_hdr(tdata->msg, PJSIP_H_CSEQ, NULL))!=NULL
 			  && (cseq->cseq == inv->invite_tsx->cseq),
 			 PJ_EINVALIDOP);
@@ -2416,5 +2421,5 @@
 						    NULL);
 		if (accept) {
-		    pjsip_msg_add_hdr(tdata->msg,
+		    pjsip_msg_add_hdr(tdata->msg, (pjsip_hdr*)
 				      pjsip_hdr_clone(tdata->pool, accept));
 		}
Index: pjproject/trunk/pjsip/src/pjsip-ua/sip_reg.c
===================================================================
--- pjproject/trunk/pjsip/src/pjsip-ua/sip_reg.c	(revision 1265)
+++ pjproject/trunk/pjsip/src/pjsip-ua/sip_reg.c	(revision 1266)
@@ -104,5 +104,5 @@
     PJ_ASSERT_RETURN(pool != NULL, PJ_ENOMEM);
 
-    regc = pj_pool_zalloc(pool, sizeof(struct pjsip_regc));
+    regc = PJ_POOL_ZALLOC_T(pool, pjsip_regc);
 
     regc->pool = pool;
@@ -110,5 +110,5 @@
     regc->token = token;
     regc->cb = cb;
-    regc->contact_buf = pj_pool_alloc(pool, PJSIP_REGC_CONTACT_BUF_SIZE);
+    regc->contact_buf = (char*)pj_pool_alloc(pool, PJSIP_REGC_CONTACT_BUF_SIZE);
     regc->expires = PJSIP_REGC_EXPIRATION_NOT_SPECIFIED;
 
@@ -387,5 +387,6 @@
 	const pjsip_route_hdr *route;
 
-	route_pos = pjsip_msg_find_hdr(tdata->msg, PJSIP_H_VIA, NULL);
+	route_pos = (pjsip_hdr*)
+		    pjsip_msg_find_hdr(tdata->msg, PJSIP_H_VIA, NULL);
 	if (!route_pos)
 	    route_pos = &tdata->msg->hdr;
@@ -393,5 +394,6 @@
 	route = regc->route_set.next;
 	while (route != &regc->route_set) {
-	    pjsip_hdr *new_hdr = pjsip_hdr_shallow_clone(tdata->pool, route);
+	    pjsip_hdr *new_hdr = (pjsip_hdr*)
+				 pjsip_hdr_shallow_clone(tdata->pool, route);
 	    pj_list_insert_after(route_pos, new_hdr);
 	    route_pos = new_hdr;
@@ -406,5 +408,6 @@
 	hdr = regc->hdr_list.next;
 	while (hdr != &regc->hdr_list) {
-	    pjsip_hdr *new_hdr = pjsip_hdr_shallow_clone(tdata->pool, hdr);
+	    pjsip_hdr *new_hdr = (pjsip_hdr*)
+				 pjsip_hdr_shallow_clone(tdata->pool, hdr);
 	    pjsip_msg_add_hdr(tdata->msg, new_hdr);
 	    hdr = hdr->next;
@@ -433,8 +436,10 @@
     /* Add Contact header. */
     msg = tdata->msg;
-    pjsip_msg_add_hdr(msg, pjsip_hdr_shallow_clone(tdata->pool, 
+    pjsip_msg_add_hdr(msg, (pjsip_hdr*)
+			   pjsip_hdr_shallow_clone(tdata->pool, 
 						   regc->contact_hdr));
     if (regc->expires_hdr)
-	pjsip_msg_add_hdr(msg, pjsip_hdr_shallow_clone(tdata->pool,
+	pjsip_msg_add_hdr(msg, (pjsip_hdr*)
+			       pjsip_hdr_shallow_clone(tdata->pool,
 						       regc->expires_hdr));
 
@@ -471,5 +476,6 @@
 
     msg = tdata->msg;
-    pjsip_msg_add_hdr(msg, pjsip_hdr_shallow_clone(tdata->pool, 
+    pjsip_msg_add_hdr(msg, (pjsip_hdr*)
+			   pjsip_hdr_shallow_clone(tdata->pool, 
 						   regc->contact_hdr));
     pjsip_msg_add_hdr( msg, (pjsip_hdr*)regc->unreg_expires_hdr);
@@ -554,5 +560,5 @@
 				   struct pj_timer_entry *entry)
 {
-    pjsip_regc *regc = entry->user_data;
+    pjsip_regc *regc = (pjsip_regc*) entry->user_data;
     pjsip_tx_data *tdata;
     pj_status_t status;
@@ -588,5 +594,5 @@
 {
     pj_status_t status;
-    pjsip_regc *regc = token;
+    pjsip_regc *regc = (pjsip_regc*) token;
     pjsip_transaction *tsx = event->body.tsx_state.tsx;
     
@@ -654,5 +660,6 @@
 	    rdata = event->body.tsx_state.src.rdata;
 	    msg = rdata->msg_info.msg;
-	    hdr = pjsip_msg_find_hdr( msg, PJSIP_H_CONTACT, NULL);
+	    hdr = (pjsip_contact_hdr*)
+		  pjsip_msg_find_hdr( msg, PJSIP_H_CONTACT, NULL);
 	    while (hdr) {
 		contact[contact_cnt++] = hdr;
@@ -660,8 +667,10 @@
 		if (hdr == (void*)&msg->hdr)
 		    break;
-		hdr = pjsip_msg_find_hdr(msg, PJSIP_H_CONTACT, hdr);
+		hdr = (pjsip_contact_hdr*)
+		      pjsip_msg_find_hdr(msg, PJSIP_H_CONTACT, hdr);
 	    }
 
-	    expires = pjsip_msg_find_hdr(msg, PJSIP_H_EXPIRES, NULL);
+	    expires = (pjsip_expires_hdr*)
+		      pjsip_msg_find_hdr(msg, PJSIP_H_EXPIRES, NULL);
 
 	    if (expires)
@@ -741,5 +750,6 @@
     /* Increment CSeq */
     cseq = ++regc->cseq_hdr->cseq;
-    cseq_hdr = pjsip_msg_find_hdr(tdata->msg, PJSIP_H_CSEQ, NULL);
+    cseq_hdr = (pjsip_cseq_hdr*)
+	       pjsip_msg_find_hdr(tdata->msg, PJSIP_H_CSEQ, NULL);
     cseq_hdr->cseq = cseq;
 
Index: pjproject/trunk/pjsip/src/pjsip-ua/sip_replaces.c
===================================================================
--- pjproject/trunk/pjsip/src/pjsip-ua/sip_replaces.c	(revision 1265)
+++ pjproject/trunk/pjsip/src/pjsip-ua/sip_replaces.c	(revision 1266)
@@ -53,5 +53,5 @@
 PJ_DEF(pjsip_replaces_hdr*) pjsip_replaces_hdr_create(pj_pool_t *pool)
 {
-    pjsip_replaces_hdr *hdr = pj_pool_zalloc(pool, sizeof(*hdr));
+    pjsip_replaces_hdr *hdr = PJ_POOL_ZALLOC_T(pool, pjsip_replaces_hdr);
     hdr->type = PJSIP_H_OTHER;
     hdr->name.ptr = "Replaces";
@@ -109,5 +109,5 @@
 			    const pjsip_replaces_hdr *rhs )
 {
-    pjsip_replaces_hdr *hdr = pj_pool_alloc(pool, sizeof(*hdr));
+    pjsip_replaces_hdr *hdr = PJ_POOL_ALLOC_T(pool, pjsip_replaces_hdr);
     pj_memcpy(hdr, rhs, sizeof(*hdr));
     pjsip_param_shallow_clone(pool, &hdr->other_param, &rhs->other_param);
@@ -145,5 +145,5 @@
 	    hdr->early_only = PJ_TRUE;
 	} else {
-	    pjsip_param *param = pj_pool_alloc(ctx->pool, sizeof(pjsip_param));
+	    pjsip_param *param = PJ_POOL_ALLOC_T(ctx->pool, pjsip_param);
 	    param->name = pname;
 	    param->value = pvalue;
@@ -319,5 +319,5 @@
 		pjsip_hdr *cloned;
 
-		cloned = pjsip_hdr_clone(tdata->pool, h);
+		cloned = (pjsip_hdr*) pjsip_hdr_clone(tdata->pool, h);
 		PJ_ASSERT_RETURN(cloned, PJ_ENOMEM);
 
Index: pjproject/trunk/pjsip/src/pjsip-ua/sip_xfer.c
===================================================================
--- pjproject/trunk/pjsip/src/pjsip-ua/sip_xfer.c	(revision 1265)
+++ pjproject/trunk/pjsip/src/pjsip-ua/sip_xfer.c	(revision 1266)
@@ -180,5 +180,5 @@
 
     /* Create xfer session */
-    xfer = pj_pool_zalloc(dlg->pool, sizeof(pjsip_xfer));
+    xfer = PJ_POOL_ZALLOC_T(dlg->pool, pjsip_xfer);
     xfer->dlg = dlg;
     xfer->sub = sub;
@@ -249,5 +249,5 @@
 
     /* Create server xfer subscription */
-    xfer = pj_pool_zalloc(dlg->pool, sizeof(pjsip_xfer));
+    xfer = PJ_POOL_ZALLOC_T(dlg->pool, pjsip_xfer);
     xfer->dlg = dlg;
     xfer->sub = sub;
@@ -287,5 +287,5 @@
 
     /* Get the xfer object. */
-    xfer = pjsip_evsub_get_mod_data(sub, mod_xfer.id);
+    xfer = (pjsip_xfer*) pjsip_evsub_get_mod_data(sub, mod_xfer.id);
     PJ_ASSERT_RETURN(xfer != NULL, PJSIP_ENOREFERSESSION);
 
@@ -374,5 +374,5 @@
 
     /* Get the xfer object. */
-    xfer = pjsip_evsub_get_mod_data(sub, mod_xfer.id);
+    xfer = (pjsip_xfer*) pjsip_evsub_get_mod_data(sub, mod_xfer.id);
     PJ_ASSERT_RETURN(xfer != NULL, PJSIP_ENOREFERSESSION);
 
@@ -399,5 +399,5 @@
 
     /* Create sipfrag content. */
-    body = pj_pool_alloc(tdata->pool, 128);
+    body = (char*) pj_pool_alloc(tdata->pool, 128);
     bodylen = pj_ansi_snprintf(body, 128, "SIP/2.0 %u %.*s",
 			       xfer_st_code,
@@ -410,5 +410,5 @@
 
     /* Create SIP message body. */
-    msg_body = pj_pool_zalloc(tdata->pool, sizeof(pjsip_msg_body));
+    msg_body = PJ_POOL_ZALLOC_T(tdata->pool, pjsip_msg_body);
     msg_body->content_type.type = STR_MESSAGE;
     msg_body->content_type.subtype = STR_SIPFRAG;
@@ -448,5 +448,5 @@
 
     /* Get the xfer object. */
-    xfer = pjsip_evsub_get_mod_data(sub, mod_xfer.id);
+    xfer = (pjsip_xfer*) pjsip_evsub_get_mod_data(sub, mod_xfer.id);
     PJ_ASSERT_RETURN(xfer != NULL, PJSIP_ENOREFERSESSION);
 
@@ -481,5 +481,5 @@
     pjsip_xfer *xfer;
 
-    xfer = pjsip_evsub_get_mod_data(sub, mod_xfer.id);
+    xfer = (pjsip_xfer*) pjsip_evsub_get_mod_data(sub, mod_xfer.id);
     PJ_ASSERT_ON_FAIL(xfer!=NULL, {return;});
 
@@ -497,5 +497,5 @@
     pjsip_xfer *xfer;
 
-    xfer = pjsip_evsub_get_mod_data(sub, mod_xfer.id);
+    xfer = (pjsip_xfer*) pjsip_evsub_get_mod_data(sub, mod_xfer.id);
     PJ_ASSERT_ON_FAIL(xfer!=NULL, {return;});
 
@@ -516,5 +516,5 @@
     pjsip_xfer *xfer;
 
-    xfer = pjsip_evsub_get_mod_data(sub, mod_xfer.id);
+    xfer = (pjsip_xfer*) pjsip_evsub_get_mod_data(sub, mod_xfer.id);
     PJ_ASSERT_ON_FAIL(xfer!=NULL, {return;});
 
@@ -557,5 +557,5 @@
     pjsip_xfer *xfer;
 
-    xfer = pjsip_evsub_get_mod_data(sub, mod_xfer.id);
+    xfer = (pjsip_xfer*) pjsip_evsub_get_mod_data(sub, mod_xfer.id);
     PJ_ASSERT_ON_FAIL(xfer!=NULL, {return;});
 
@@ -572,5 +572,5 @@
     pjsip_xfer *xfer;
 
-    xfer = pjsip_evsub_get_mod_data(sub, mod_xfer.id);
+    xfer = (pjsip_xfer*) pjsip_evsub_get_mod_data(sub, mod_xfer.id);
     PJ_ASSERT_ON_FAIL(xfer!=NULL, {return;});
 
@@ -595,5 +595,5 @@
     pjsip_xfer *xfer;
 
-    xfer = pjsip_evsub_get_mod_data(sub, mod_xfer.id);
+    xfer = (pjsip_xfer*) pjsip_evsub_get_mod_data(sub, mod_xfer.id);
     PJ_ASSERT_ON_FAIL(xfer!=NULL, {return;});
 
Index: pjproject/trunk/pjsip/src/pjsip/sip_endpoint.c
===================================================================
--- pjproject/trunk/pjsip/src/pjsip/sip_endpoint.c	(revision 1265)
+++ pjproject/trunk/pjsip/src/pjsip/sip_endpoint.c	(revision 1266)
@@ -168,5 +168,5 @@
     pj_status_t status = PJ_SUCCESS;
     pjsip_module *m;
-    int i;
+    unsigned i;
 
     pj_rwmutex_lock_write(endpt->mod_mutex);
@@ -248,5 +248,6 @@
 
     /* Make sure the module exists in the array. */
-    PJ_ASSERT_ON_FAIL(	mod->id>=0 && mod->id<PJ_ARRAY_SIZE(endpt->modules) &&
+    PJ_ASSERT_ON_FAIL(	mod->id>=0 && 
+			mod->id<(int)PJ_ARRAY_SIZE(endpt->modules) &&
 			endpt->modules[mod->id] == mod,
 			{status = PJ_ENOTFOUND; goto on_return;});
@@ -1080,5 +1081,5 @@
 
     len = pj_ansi_strlen(format);
-    if (len < sizeof(newformat)-30) {
+    if (len < (int)sizeof(newformat)-30) {
 	pj_str_t errstr;
 
Index: pjproject/trunk/pjsip/src/pjsip/sip_msg.c
===================================================================
--- pjproject/trunk/pjsip/src/pjsip/sip_msg.c	(revision 1265)
+++ pjproject/trunk/pjsip/src/pjsip/sip_msg.c	(revision 1266)
@@ -98,5 +98,5 @@
 static int init_status_phrase()
 {
-    int i;
+    unsigned i;
     pj_str_t default_reason_phrase = { "Default status message", 22};
 
@@ -195,5 +195,5 @@
 				  pj_str_t *str)
 {
-    int i;
+    unsigned i;
     for (i=0; i<PJ_ARRAY_SIZE(method_names); ++i) {
 	if (pj_memcmp(str->ptr, method_names[i]->ptr, str->slen)==0 || 
@@ -516,5 +516,6 @@
     }
 
-    return (code>=100 && code<(sizeof(status_phrase)/sizeof(status_phrase[0]))) ? 
+    return (code>=100 && 
+	    code<(int)(sizeof(status_phrase)/sizeof(status_phrase[0]))) ? 
 	&status_phrase[code] : &status_phrase[0];
 }
Index: pjproject/trunk/pjsip/src/pjsip/sip_transport.c
===================================================================
--- pjproject/trunk/pjsip/src/pjsip/sip_transport.c	(revision 1265)
+++ pjproject/trunk/pjsip/src/pjsip/sip_transport.c	(revision 1266)
@@ -98,5 +98,5 @@
  * Transport names.
  */
-struct
+struct transport_names_t
 {
     pjsip_transport_type_e type;
@@ -217,5 +217,5 @@
 
     /* Check that argument is valid. */
-    PJ_ASSERT_RETURN(type < PJ_ARRAY_SIZE(transport_names), 0);
+    PJ_ASSERT_RETURN((unsigned)type < PJ_ARRAY_SIZE(transport_names), 0);
 
     /* Return transport flag. */
@@ -236,5 +236,5 @@
 
     /* Check that argument is valid. */
-    PJ_ASSERT_RETURN(type < PJ_ARRAY_SIZE(transport_names), 5060);
+    PJ_ASSERT_RETURN((unsigned)type < PJ_ARRAY_SIZE(transport_names), 5060);
 
     /* Return the port. */
@@ -254,5 +254,5 @@
 
     /* Check that argument is valid. */
-    PJ_ASSERT_RETURN(type < PJ_ARRAY_SIZE(transport_names), "Unknown");
+    PJ_ASSERT_RETURN((unsigned)type<PJ_ARRAY_SIZE(transport_names), "Unknown");
 
     /* Return the port. */
@@ -415,5 +415,5 @@
     }
 
-    if (len < 1 || len >= sizeof(info_buf)) {
+    if (len < 1 || len >= (int)sizeof(info_buf)) {
 	return (char*)obj_name;
     }
Index: pjproject/trunk/pjsip/src/pjsip/sip_transport_tls_ossl.c
===================================================================
--- pjproject/trunk/pjsip/src/pjsip/sip_transport_tls_ossl.c	(revision 1265)
+++ pjproject/trunk/pjsip/src/pjsip/sip_transport_tls_ossl.c	(revision 1266)
@@ -260,5 +260,5 @@
 {
     enum { M = 48 };
-    host_port->host.ptr = pj_pool_alloc(pool, M);
+    host_port->host.ptr = (char*)pj_pool_alloc(pool, M);
     host_port->host.slen = pj_ansi_snprintf( host_port->host.ptr, M, "%s", 
 					    pj_inet_ntoa(addr->sin_addr));
@@ -270,5 +270,5 @@
 static int password_cb(char *buf, int num, int rwflag, void *user_data)
 {
-    struct tls_listener *lis = user_data;
+    struct tls_listener *lis = (struct tls_listener*) user_data;
 
     PJ_UNUSED_ARG(rwflag);
@@ -905,5 +905,5 @@
 
 
-    listener = pj_pool_zalloc(pool, sizeof(struct tls_listener));
+    listener = PJ_POOL_ZALLOC_T(pool, struct tls_listener);
     listener->factory.pool = pool;
     listener->factory.type = PJSIP_TRANSPORT_TLS;
@@ -1037,6 +1037,5 @@
 	}
 
-	listener->accept_op[i] = pj_pool_zalloc(pool, 
-						sizeof(struct pending_accept));
+	listener->accept_op[i] = PJ_POOL_ZALLOC_T(pool, struct pending_accept);
 	pj_ioqueue_op_key_init(&listener->accept_op[i]->op_key, 
 				sizeof(listener->accept_op[i]->op_key));
@@ -1192,5 +1191,5 @@
      * Create and initialize basic transport structure.
      */
-    tls = pj_pool_zalloc(pool, sizeof(*tls));
+    tls = PJ_POOL_ZALLOC_T(pool, struct tls_transport);
     tls->sock = sock;
     tls->is_server = is_server;
@@ -1218,5 +1217,5 @@
     tls->base.flag = pjsip_transport_get_flag_from_type(PJSIP_TRANSPORT_TLS);
 
-    tls->base.info = pj_pool_alloc(pool, 64);
+    tls->base.info = (char*) pj_pool_alloc(pool, 64);
     pj_ansi_snprintf(tls->base.info, 64, "TLS to %s:%d",
 		     pj_inet_ntoa(remote->sin_addr), 
@@ -1636,5 +1635,5 @@
     int err_cnt = 0;
 
-    listener = pj_ioqueue_get_user_data(key);
+    listener = (struct tls_listener*) pj_ioqueue_get_user_data(key);
     accept_op = (struct pending_accept*) op_key;
 
@@ -1695,5 +1694,5 @@
 	    pool = pjsip_endpt_create_pool(listener->endpt, "tlss%p", 
 					   POOL_TP_INIT, POOL_TP_INC);
-	    new_op = pj_pool_zalloc(pool, sizeof(struct pending_accept));
+	    new_op = PJ_POOL_ZALLOC_T(pool, struct pending_accept);
 	    new_op->pool = pool;
 	    new_op->listener = listener;
@@ -1757,7 +1756,8 @@
                               pj_ssize_t bytes_sent)
 {
-    struct tls_transport *tls = pj_ioqueue_get_user_data(key);
+    struct tls_transport *tls;
     pjsip_tx_data_op_key *tdata_op_key = (pjsip_tx_data_op_key*)op_key;
 
+    tls = (struct tls_transport*) pj_ioqueue_get_user_data(key);
     tdata_op_key->tdata = NULL;
 
@@ -1790,6 +1790,5 @@
     struct delayed_tdata *delayed_tdata;
 
-    delayed_tdata = pj_pool_alloc(tdata->pool, 
-				  sizeof(*delayed_tdata));
+    delayed_tdata = PJ_POOL_ALLOC_T(tdata->pool, struct delayed_tdata);
     delayed_tdata->tdata_op_key = &tdata->op_key;
     pj_list_push_back(&tls->delayed_list, delayed_tdata);
@@ -2098,5 +2097,5 @@
     int addrlen;
 
-    tls = pj_ioqueue_get_user_data(key);
+    tls = (struct tls_transport*) pj_ioqueue_get_user_data(key);
 
     /* Check connect() status */
